#pragma once

#include <stdbool.h>
#include <stdio.h>
#include <stdlib.h>

// A regular node with a left and right branch
struct Node {
  int data;
  struct Node *left, *right;
};
typedef struct Node Node;

// Represents a tree with a root node
struct Tree {
  Node *root;
};
typedef struct Tree Tree;

int tree_insert(Tree *tree, int data);
int tree_remove(Node **node, int data);
int tree_clear(Node *node);
int tree_size(Node *node);
bool tree_contains(Node *node, int data);
